﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WG_SummaryFromHiddenColumn
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("End Time", typeof(string));
            dt.Columns.Add("Actual Time", typeof(string));
            dt.Columns.Add("Policy Time", typeof(string));
            dt.Columns.Add("IntSeconds", typeof(int));

            dt.Rows.Add(new object[] { "3:05 PM", "6:10", "6:10", 22200 });
            dt.Rows.Add(new object[] { "3:05 PM", "6:10", "6:10", 22200 });
            dt.Rows.Add(new object[] { "3:05 PM", "6:10", "6:10", 22200 });
            dt.Rows.Add(new object[] { "9:00 AM", "1:00", "1:00", 3600 });

            ultraGrid1.DataSource = dt;

        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            var band = e.Layout.Bands[0];

            band.Columns["IntSeconds"].Hidden = true;

            band.SummaryFooterCaption = "Totals";

            InitSummary(band, "Actual Time");
            InitSummary(band, "Policy Time");

        }

        private static void InitSummary(UltraGridBand band, string columnKey)
        {
            var actualTimeSummary = band.Summaries.Add("");

            actualTimeSummary.CustomSummaryCalculator = new HiddenFieldSummaryCalculator();
            actualTimeSummary.SummaryType = SummaryType.Custom;
            actualTimeSummary.SummaryPositionColumn = band.Columns[columnKey];
            actualTimeSummary.SummaryPosition = SummaryPosition.UseSummaryPositionColumn;
            actualTimeSummary.SourceColumn = band.Columns[columnKey];
            actualTimeSummary.DisplayFormat = "{0}";
        }
    }
}
